Imports CKAccount.CC
Imports System.Data.OleDb
Imports System.IO

Public Class F3030_GeneralLedger

    Const TABLE_NAME As String = "F3030_DT"
    Const F_NAME As String = "GeneralLedger"

    Private _dt As DataTable
    
    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnBack.Click
        Me.Close()
    End Sub

    ''' <summary>
    ''' []{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles btnPrint.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim code As String = cbxAccount.Text.Substring(0, CodeLenAccount)
        Dim account As String = cbxAccount.Text.Substring(CodeLenAccount + 1)
        account = account & "(" & code & ")"
        Dim syear As String = cbxYear.Text
        Dim term As String = syear & "N11`" & syear & "N1231"

        FormDisabled(Me)
        PrintTable(_dt, account, term)
        FormEnabled(Me)
    End Sub

    ''' <summary>
    ''' [Cbx_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Cbx_KeyDown(ByVal sender As System.Object, ByVal e As KeyEventArgs) _
            Handles cbxYear.KeyDown, cbxAccount.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [cbxAccount_SIChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxAccount_SIChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxAccount.SelectedIndexChanged

        Dim method As String = New StackFrame(0).GetMethod.Name

        grdView.DataSource = Nothing
        grdView.Visible = False
        btnPrint.Enabled = False

        lblDeCr.Text = String.Empty
        If cbxAccount.SelectedIndex < 0 Then Exit Sub

        Try
            '*** ݂ؑ̎擾
            Using cn As New OleDbConnection(CnSt)
                Dim code As String = cbxAccount.Text.Substring(0, CodeLenAccount)
                Dim sSQL As String = "SELECT ؑ" & _
                                    " FROM T_Ȗڃ}X^" & _
                                    " WHERE ȖC = @code"

                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@code", code)
                    Dim dt As New DataTable
                    da.Fill(dt)

                    If dt.Rows.Count > 0 Then
                        lblDeCr.Text = dt.Rows(0).Item(0).ToString
                    End If
                End Using
            End Using

            If lblMsg.Visible Then Exit Sub

            ShowGrid()

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try

    End Sub

    ''' <summary>
    ''' [cbxYear_SIChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_SIChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxYear.SelectedIndexChanged

        Dim method As String = New StackFrame(0).GetMethod.Name

        grdView.DataSource = Nothing
        grdView.Visible = False
        btnPrint.Enabled = False
        lblMsg.Visible = False

        If cbxYear.SelectedIndex < 0 Then Exit Sub

        Try
            '*** Nx̎df[^L̊mF
            Dim count As Integer
            Using cn As New OleDbConnection(CnSt)
                Dim syear As String = cbxYear.Text
                Dim sSQL As String = "SELECT COUNT(ʔ) AS DataCount" & _
                                    " FROM T_d" & _
                                    " WHERE N LIKE @year"

                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@year", syear & "%")
                    Dim dt As New DataTable
                    da.Fill(dt)
                    count = Convert.ToInt32(dt.Rows(0).Item("DataCount"))
                End Using
            End Using

            If count = 0 Then
                lblMsg.Visible = True
            Else
                If cbxAccount.SelectedIndex > -1 Then
                    ShowGrid()
                End If
            End If

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As System.Object, _
            ByVal e As FormClosingEventArgs) Handles Me.FormClosing

        If Not _dt Is Nothing Then
            grdView.DataSource = Nothing
            _dt.Clear()
            _dt = Nothing
        End If
        F1000_Menu.Show()
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load

        SetForm(Me)
        FillCbxAccount()
        FillCbxYear()

        lblDeCr.Text = String.Empty
        cbxYear.Text = Year(Now).ToString
    End Sub


    ''' <summary>
    ''' [FillCbxAccount]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCbxAccount()

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            Using cn As New OleDbConnection(CnSt)
                Dim sSQL As String = "SELECT ȖC, Ȗ" & _
                                    " FROM T_Ȗڃ}X^" & _
                                    " ORDER BY ȖC"

                Using da As New OleDbDataAdapter(sSQL, cn)
                    Dim dt As New DataTable
                    da.Fill(dt)

                    With dt
                        If .Rows.Count > 0 Then
                            For i As Integer = 0 To .Rows.Count - 1
                                cbxAccount.Items.Add(.Rows(i).Item("ȖC").ToString & ") " & _
                                    .Rows(i).Item("Ȗ").ToString)
                            Next
                        End If

                    End With
                End Using
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)

        End Try
    End Sub

    ''' <summary>
    ''' [FillCbxYear]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCbxYear()

        For i As Integer = MinYear To MaxYear
            cbxYear.Items.Add(i.ToString)
        Next
    End Sub

    ''' <summary>
    ''' [PrintTable]\bh
    ''' </summary>
    ''' <param name="vdt"></param>
    ''' <param name="vaccount"></param>
    ''' <param name="vterm"></param>
    ''' <remarks></remarks>
    Private Sub PrintTable(ByVal vdt As DataTable, _
                            ByVal vaccount As String, _
                            ByVal vterm As String)

        Const ORIGINAL_FILE As String = "茳.xls"
        Const TARGET_FILE As String = "茳.xls"

        Dim method As String = New StackFrame(0).GetMethod.Name
        Dim target As String = FILE_FOLDER & TARGET_FILE
        Dim original As String = FILE_FOLDER & ORIGINAL_FILE

        If Not System.IO.File.Exists(original) Then
            ShowMsg("[" & original & "]܂B", MSG_EXC)
            Exit Sub
        End If

        Dim dt As DataTable = vdt
        Dim exlapp As New Excel.Application
        Try
            exlapp.Visible = False
            'exlapp.Visible = True
            Try
                exlapp.Workbooks.Open(original)
            Catch ex As Exception
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & ORIGINAL_FILE & "]ĂB", MSG_EXC)
                Exit Sub
            End Try

            exlapp.DisplayAlerts = False
            Dim book1 As Excel.Workbook = exlapp.ActiveWorkbook
            Try
                book1.SaveAs(target)
            Catch ex As Exception
                book1.Close()
                book1 = Nothing
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & TARGET_FILE & "]ĂB", MSG_EXC)
                Exit Sub
            End Try
            exlapp.DisplayAlerts = True

            Dim sheet1 As Excel.Worksheet = CType(book1.Worksheets(1), Excel.Worksheet)
            With sheet1
                .Cells(2, "B") = vaccount
                .Cells(3, "A") = vterm
                Dim iend As Integer = 5
                If dt.Rows.Count > 0 Then
                    For i As Integer = 0 To dt.Rows.Count - 1
                        .Cells(i + 5, "A") = dt.Rows(i)("N")
                        .Cells(i + 5, "B") = dt.Rows(i)("ؕ")
                        .Cells(i + 5, "C") = dt.Rows(i)("ݕ")
                        .Cells(i + 5, "D") = dt.Rows(i)("c")
                        .Cells(i + 5, "E") = dt.Rows(i)("Ȗ")
                        .Cells(i + 5, "F") = dt.Rows(i)("Ev")
                        iend = i + 5
                    Next
                End If
                .Range("A5", .Cells(iend, "F")).Borders.LineStyle = Excel.XlLineStyle.xlContinuous
                .PrintOut()
            End With

            exlapp.DisplayAlerts = False
            book1.Save()
            book1.Close()
            book1 = Nothing
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowMsg("I܂B", MSG_INF)

        Catch ex As Exception

            exlapp.DisplayAlerts = False
            For Each wbook As Excel.Workbook In exlapp.Workbooks
                wbook.Close()
            Next
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [ShowGrid]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowGrid()

        If Not _dt Is Nothing Then
            _dt.Clear()
            grdView.DataSource = Nothing
        End If

        Dim code As String = cbxAccount.Text
        If code.Length < CodeLenAccount Then Exit Sub
        code = code.Substring(0, CodeLenAccount)

        Dim syear As String = cbxYear.Text
        Dim sday1 As String = syear & "0101"
        Dim decr As String = lblDeCr.Text       ' ؑ(lblDeCr)

        Dim msg As String = String.Empty

        Using cn As New OleDbConnection(CnSt)
            cn.Open()
            '*** [T_茳]̏(f[^NA)
            Dim sSQL1 As String = "DELETE FROM T_茳"
            Using cmd1 As New OleDbCommand(sSQL1, cn)
                cmd1.ExecuteNonQuery()
            End Using

            '*** [T_茳]ɔNf[^}
            Dim sSQL2 As String = "SELECT z" & _
                                 " FROM T_ݒ" & _
                                 " WHERE ȖC = @code2 AND Nx = @year2"
            Dim dini As Decimal  ' decIni
            Using da2 As New OleDbDataAdapter(sSQL2, cn)
                da2.SelectCommand.Parameters.AddWithValue("@code2", code)
                da2.SelectCommand.Parameters.AddWithValue("@year2", syear)
                Dim dt2 As New DataTable
                da2.Fill(dt2)

                If dt2.Rows.Count = 0 Then
                    dini = 0    '  ̃R[hAVer1.2.0 ŕύX  
                    'ShowMsg("̉Ȗڂ͊ݒ肪Ă܂B", MSG_EXC)
                    'cbxAccount.SelectedIndex = -1
                    'Exit Sub

                Else
                    dini = Convert.ToDecimal(dt2.Rows(0).Item(0))
                End If
            End Using

            Dim sSQL3 As String = _
                "INSERT INTO T_茳 (ʔ,N,c) " & _
                "VALUES ('', @day13, @dini3)"
            Using cmd3 As New OleDbCommand(sSQL3, cn)
                cmd3.Parameters.AddWithValue("@day13", sday1)
                cmd3.Parameters.AddWithValue("@dini3", dini)
                cmd3.ExecuteNonQuery()
            End Using

            '*** [T_茳]Ɏؕf[^}
            Dim sSQL4 As String = _
                "INSERT INTO T_茳 (ʔ, N, ؕ, Ȗ, Ev) " & _
                "SELECT A.ʔ, A.N, A.z, B.Ȗ, A.Ev" & _
                    " FROM T_d A LEFT OUTER JOIN T_Ȗڃ}X^ B" & _
                        " ON A.ݕC = B.ȖC" & _
                    " WHERE A.ؕC = @code4 AND A.N LIKE @year4"
            Using cmd4 As New OleDbCommand(sSQL4, cn)
                cmd4.Parameters.AddWithValue("@code4", code)
                cmd4.Parameters.AddWithValue("@year4", syear & "%")
                cmd4.ExecuteNonQuery()
            End Using

            '*** [T_茳]ɑݕf[^}
            Dim sSQL5 As String = _
                "INSERT INTO T_茳 (ʔ, N, ݕ, Ȗ, Ev) " & _
                "SELECT A.ʔ, A.N, A.z, B.Ȗ, A.Ev" & _
                    " FROM T_d A LEFT OUTER JOIN T_Ȗڃ}X^ B" & _
                            " ON A.ؕC = B.ȖC" & _
                    " WHERE A.ݕC = @code5 AND A.N LIKE @year5"
            Using cmd5 As New OleDbCommand(sSQL5, cn)
                cmd5.Parameters.AddWithValue("@code5", code)
                cmd5.Parameters.AddWithValue("@year5", syear & "%")
                cmd5.ExecuteNonQuery()
            End Using

            '*** c̎Zo  Obhւ̃f[^\
            Dim sSQL6 As String = "SELECT N," & _
                                    " ؕ," & _
                                    " ݕ," & _
                                    " c," & _
                                    " Ȗ," & _
                                    " Ev" & _
                                " FROM T_茳" & _
                                " ORDER BY N, ʔ"

            Using da6 As New OleDbDataAdapter(sSQL6, cn)
                _dt = New DataTable
                da6.Fill(_dt)

                If _dt.Rows.Count > 0 Then
                    Dim dzan As Decimal = Convert.ToDecimal(_dt.Rows(0).Item("c"))

                    For i As Integer = 1 To _dt.Rows.Count - 1
                        Dim debtor As Decimal = 0
                        If Not DBNull.Value.Equals(_dt.Rows(i).Item("ؕ")) Then
                            debtor = Convert.ToDecimal(_dt.Rows(i).Item("ؕ"))
                        End If
                        Dim creditor As Decimal = 0
                        If Not DBNull.Value.Equals(_dt.Rows(i).Item("ݕ")) Then
                            creditor = Convert.ToDecimal(_dt.Rows(i).Item("ݕ"))
                        End If

                        If decr = "" Then
                            dzan += debtor - creditor
                        Else
                            dzan += creditor - debtor
                        End If

                        With _dt.Rows(i)
                            .BeginEdit()
                            .Item("c") = dzan
                            .EndEdit()
                        End With
                    Next

                    With grdView
                        .Visible = True
                        .DataSource = _dt
                        .Columns("N").Width = 90
                        .Columns("ؕ").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("ؕ").DefaultCellStyle.Format = "#,##0"
                        .Columns("ؕ").Width = 100
                        .Columns("ݕ").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("ݕ").DefaultCellStyle.Format = "#,##0"
                        .Columns("ݕ").Width = 100
                        .Columns("c").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("c").DefaultCellStyle.Format = "#,##0"
                        .Columns("c").Width = 100
                        .Columns("Ȗ").Width = 150
                        .Columns("Ev").Width = 200
                        SetGridProperty(grdView)
                        .FirstDisplayedScrollingRowIndex = grdView.Rows.Count - 1
                        .ClearSelection()
                    End With

                    btnPrint.Enabled = True
                End If
            End Using
            cn.Close()
        End Using
    End Sub


End Class