Imports CKAccount.CC
Imports System.Data.OleDb

Public Class F3040_CashIO

    Const TABLE_NAME As String = "F3040_DT"
    Const F_NAME As String = "CashIO"

    Private _dt As DataTable

    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnBack.Click
        Me.Close()
    End Sub

    ''' <summary>
    ''' []{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnPrint_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnPrint.Click

        Dim method As String = New StackFrame(0).GetMethod.Name
        Dim syear As String = cbxYear.Text
        Dim term As String = syear & "N11`" & syear & "N1231"

        FormDisabled(Me)
        PrintTable(_dt, term)
        FormEnabled(Me)
    End Sub

    ''' <summary>
    ''' [cbxYear_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_KeyDown(ByVal sender As System.Object, _
            ByVal e As KeyEventArgs) Handles cbxYear.KeyDown

        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [cbxYear_SIChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_SIChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxYear.SelectedIndexChanged

        Dim method As String = New StackFrame(0).GetMethod.Name

        grdView.DataSource = Nothing
        grdView.Visible = False
        btnPrint.Enabled = False
        lblMsg.Visible = False

        If cbxYear.SelectedIndex < 0 Then Exit Sub

        Dim syear As String = cbxYear.Text
        Try
            '*** Nx̎df[^L̊mF
            Dim existData As Boolean = True
            Using cn As New OleDbConnection(CnSt)
                Dim sSQL As String = "SELECT ʔ" & _
                                " FROM T_d" & _
                                " WHERE (ؕC = @debtor OR ݕC = @creditor)" & _
                                    " AND N LIKE @year"
                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@debtor", AcCodeCash)
                    da.SelectCommand.Parameters.AddWithValue("@creditor", AcCodeCash)
                    da.SelectCommand.Parameters.AddWithValue("@year", syear & "%")
                    Dim dt As New DataTable
                    da.Fill(dt)
                    If dt.Rows.Count = 0 Then existData = False
                End Using
            End Using

            If Not existData Then
                lblMsg.Visible = True
            Else
                ShowGrid()
            End If

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As Object, _
            ByVal e As FormClosingEventArgs) Handles Me.FormClosing

        If Not _dt Is Nothing Then
            grdView.DataSource = Nothing
            _dt.Clear()
            _dt = Nothing
        End If
        F1000_Menu.Show()
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles MyBase.Load

        SetForm(Me)
        FillCbxYear()
        cbxYear.Text = Year(Now).ToString
    End Sub


    ''' <summary>
    ''' [FillCbxYear]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCbxYear()

        For i As Integer = MinYear To MaxYear
            cbxYear.Items.Add(i.ToString)
        Next
    End Sub

    ''' <summary>
    ''' [PrintTable]\bh
    ''' </summary>
    ''' <param name="vdt"></param>
    ''' <param name="vterm"></param>
    ''' <remarks></remarks>
    Private Sub PrintTable(ByVal vdt As DataTable, ByVal vterm As String)

        Const ORIGINAL_FILE As String = "o[.xls"
        Const TARGET_FILE As String = "o[.xls"

        Dim method As String = New StackFrame(0).GetMethod.Name
        Dim target As String = FILE_FOLDER & TARGET_FILE
        Dim original As String = FILE_FOLDER & ORIGINAL_FILE
        If Not System.IO.File.Exists(original) Then
            ShowMsg("[" & original & "]܂B", MSG_EXC)
            Exit Sub
        End If

        Dim dt As DataTable = vdt
        Dim exlapp As New Excel.Application
        Try
            exlapp.Visible = False
            'exlapp.Visible = True
            Try
                exlapp.Workbooks.Open(original)
            Catch ex As Exception
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & ORIGINAL_FILE & "]ĂB", MSG_EXC)
                Exit Sub
            End Try

            exlapp.DisplayAlerts = False
            Dim book1 As Excel.Workbook = exlapp.ActiveWorkbook
            Try
                book1.SaveAs(target)
            Catch ex As Exception
                book1.Close()
                book1 = Nothing
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & TARGET_FILE & "]ĂB", MSG_EXC)
                Exit Sub
            End Try
            exlapp.DisplayAlerts = True

            Dim sheet1 As Excel.Worksheet = CType(book1.Worksheets(1), Excel.Worksheet)
            With sheet1
                .Cells(3, "A") = vterm
                Dim iend As Integer = 5
                If dt.Rows.Count > 0 Then
                    For i As Integer = 0 To dt.Rows.Count - 1
                        .Cells(i + 5, "A") = dt.Rows(i)("N")
                        .Cells(i + 5, "B") = dt.Rows(i)("a")
                        .Cells(i + 5, "C") = dt.Rows(i)("o")
                        .Cells(i + 5, "D") = dt.Rows(i)("c")
                        .Cells(i + 5, "E") = dt.Rows(i)("Ȗ")
                        .Cells(i + 5, "F") = dt.Rows(i)("Ev")
                        iend = i + 5
                    Next
                End If
                .Range("A5", .Cells(iend, "F")).Borders.LineStyle = Excel.XlLineStyle.xlContinuous
                .PrintOut()
            End With

            exlapp.DisplayAlerts = False
            book1.Save()
            book1.Close()
            book1 = Nothing
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowMsg("I܂B", MSG_INF)

        Catch ex As Exception

            exlapp.DisplayAlerts = False
            For Each wbook As Excel.Workbook In exlapp.Workbooks
                wbook.Close()
            Next
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [ShowGrid]
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowGrid()

        If Not _dt Is Nothing Then
            _dt.Clear()
            grdView.DataSource = Nothing
        End If

        Dim syear As String = cbxYear.Text
        Dim sday1 As String = syear & "0101"
        'Dim strDay2 As String = strYear & "1231"

        Dim msg As String = String.Empty

        Using cn As New OleDbConnection(CnSt)
            cn.Open()
            '*** [T_o[]̏(f[^NA)
            Dim sSQL1 As String = "DELETE FROM T_o["
            Using cmd1 As New OleDbCommand(sSQL1, cn)
                cmd1.ExecuteNonQuery()
            End Using

            '*** [T_o[]ɔNf[^}
            Dim sSQL2 As String = "SELECT z" & _
                                " FROM T_ݒ" & _
                                " WHERE ȖC = @code2 AND Nx = @year2"
            Dim dini As Decimal
            Using da2 As New OleDbDataAdapter(sSQL2, cn)
                da2.SelectCommand.Parameters.AddWithValue("@code2", AcCodeCash)
                da2.SelectCommand.Parameters.AddWithValue("@year2", syear)
                Dim dt2 As New DataTable
                da2.Fill(dt2)

                If dt2.Rows.Count = 0 Then
                    msg = syear & "Nx͊ݒ肪Ă܂B"
                    ShowMsg(msg, MSG_EXC)
                    Exit Sub

                Else
                    dini = Convert.ToDecimal(dt2.Rows(0).Item(0))
                End If
            End Using

            Dim sSQL3 As String = _
                    "INSERT INTO T_o[ (ʔ,N,c) " & _
                    "VALUES ('', @day13, @dini3)"
            Using cmd3 As New OleDbCommand(sSQL3, cn)
                cmd3.Parameters.AddWithValue("@day13", sday1)
                cmd3.Parameters.AddWithValue("@dini3", dini)
                cmd3.ExecuteNonQuery()
            End Using

            '*** [T_o[]Ɏؕf[^}
            Dim sSQL4 As String = _
                "INSERT INTO T_o[ (ʔ, N, a, ȖC, Ev) " & _
                "SELECT ʔ, N, z, ݕC, Ev" & _
                    " FROM T_d" & _
                    " WHERE ؕC = @code4 AND N LIKE @year4"
            Using cmd4 As New OleDbCommand(sSQL4, cn)
                cmd4.Parameters.AddWithValue("@code4", AcCodeCash)
                cmd4.Parameters.AddWithValue("@year4", syear & "%")
                cmd4.ExecuteNonQuery()
            End Using

            '*** [T_o[]ɑݕf[^}
            Dim sSQL5 As String = _
                "INSERT INTO T_o[ (ʔ, N, o, ȖC, Ev) " & _
                "SELECT ʔ, N, z, ؕC, Ev" & _
                    " FROM T_d" & _
                    " WHERE ݕC = @code5 AND N LIKE @year5"
            Using cmd5 As New OleDbCommand(sSQL5, cn)
                cmd5.Parameters.AddWithValue("@code5", AcCodeCash)
                cmd5.Parameters.AddWithValue("@year5", syear & "%")
                cmd5.ExecuteNonQuery()
            End Using

            '*** c̎Zo  Obhւ̃f[^\
            Dim sSQL6 As String = "SELECT A.N," & _
                                    " A.a," & _
                                    " A.o," & _
                                    " A.c," & _
                                    " M.Ȗ AS Ȗ," & _
                                    " Ev," & _
                                    " A.ʔ" & _
                                " FROM T_o[ A LEFT OUTER JOIN T_Ȗڃ}X^ M" & _
                                    " ON A.ȖC = M.ȖC" & _
                                " ORDER BY A.N, A.ʔ"

            Using da6 As New OleDbDataAdapter(sSQL6, cn)
                _dt = New DataTable
                da6.Fill(_dt)

                If _dt.Rows.Count > 0 Then
                    Dim dzan As Decimal = Convert.ToDecimal(_dt.Rows(0).Item("c"))

                    For i As Integer = 1 To _dt.Rows.Count - 1
                        Dim debtor As Decimal = 0
                        If Not DBNull.Value.Equals(_dt.Rows(i).Item("a")) Then
                            debtor = Convert.ToDecimal(_dt.Rows(i).Item("a"))
                        End If
                        Dim creditor As Decimal = 0
                        If Not DBNull.Value.Equals(_dt.Rows(i).Item("o")) Then
                            creditor = Convert.ToDecimal(_dt.Rows(i).Item("o"))
                        End If

                        dzan += debtor - creditor

                        With _dt.Rows(i)
                            .BeginEdit()
                            .Item("c") = dzan
                            .EndEdit()
                        End With
                    Next

                    With grdView
                        .Visible = True
                        .DataSource = _dt
                        .Columns("N").Width = 90
                        .Columns("a").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("a").DefaultCellStyle.Format = "#,##0"
                        .Columns("a").Width = 100
                        .Columns("o").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("o").DefaultCellStyle.Format = "#,##0"
                        .Columns("o").Width = 100
                        .Columns("c").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("c").DefaultCellStyle.Format = "#,##0"
                        .Columns("c").Width = 100
                        .Columns("Ȗ").Width = 150
                        .Columns("Ev").Width = 200
                        .Columns("ʔ").Visible = False
                        SetGridProperty(grdView)
                        .FirstDisplayedScrollingRowIndex = grdView.Rows.Count - 1
                        .ClearSelection()
                    End With
                    btnPrint.Enabled = True
                End If
            End Using
            cn.Close()
        End Using
    End Sub

End Class